// Utils
module.exports = utils = {};

var { Cc, Ci, Cu, Cm, Cr } = require('chrome');
var _ = require('sdk/l10n').get;

utils.openFile = function (val) {
  var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
  var uri = ioService.newURI(val, null, null);
  if (uri instanceof Ci.nsIFileURL) {
    uri.file.QueryInterface(Ci.nsILocalFile).launch();
  }
}

// Gets icon for notification based on 'system.name' or 'notifyIcon' param
utils.getIcon = function () {
  var sps = require("sdk/simple-prefs").prefs;
  var system = require("sdk/system");
  
  var picon = sps['notifyIcon'];
  if (picon == "default") {
     
    if (system.name == "Iceweasel")
      picon = "iceweasel";
    if (system.name == "Thunderbird")
      picon = "thunderbird";
    if (system.name == "Firefox")
      picon = "firefox";

    // default Firefox icon
    if (picon == "default")
      picon = "firefox";
  }
  return picon;
}